"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.extractDefinitions = void 0;
const data_with_position_1 = require("data-with-position");
const narrative_schema_common_1 = require("narrative-schema-common");
const extractDefinitions = (dataWithPosition, narrativeSchema) => {
    const stylingDataWithPosition = dataWithPosition.styling;
    const kindOfStylingDataWithPosition = (0, data_with_position_1.getKind)(stylingDataWithPosition);
    if (kindOfStylingDataWithPosition === "null" ||
        kindOfStylingDataWithPosition === "undefined") {
        return [];
    }
    if (kindOfStylingDataWithPosition !== "object") {
        narrativeSchema.message(`Expected styling to be an object, got ${kindOfStylingDataWithPosition}`, (0, data_with_position_1.getPosition)(stylingDataWithPosition), "narrative-schema:styling");
        return [];
    }
    const data = {};
    const kindOfCssLeaf = (0, data_with_position_1.getKind)(stylingDataWithPosition.css);
    if (kindOfCssLeaf === "null" ||
        kindOfCssLeaf === "undefined" ||
        kindOfCssLeaf === "string") {
        data.css = (0, data_with_position_1.getValue)(stylingDataWithPosition.css);
    }
    else {
        narrativeSchema.message(`Expected styling.css to be a string, got ${kindOfCssLeaf}`, (0, data_with_position_1.getPosition)(kindOfCssLeaf), "narrative-schema:styling");
        data.css = "";
    }
    (0, narrative_schema_common_1.reportUnusedDataKeys)(narrativeSchema, stylingDataWithPosition, data, [
        "styling",
    ]);
    if (data.css) {
        return [
            {
                dataWithPosition: stylingDataWithPosition,
                data,
                dataPath: ["styling", "css"],
            },
        ];
    }
    return [];
};
exports.extractDefinitions = extractDefinitions;
//# sourceMappingURL=extractDefinitions.js.map